// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S102_JointMinistries.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S102_JointMinistries extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int ministriesState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\5\2\0\2\1"+
    "\1\0\1\6\12\7\1\10\1\11\5\0\1\12\1\13"+
    "\1\14\1\15\1\16\3\17\1\20\1\17\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\17\1\27\1\30\1\31"+
    "\2\17\1\32\1\17\1\33\1\17\1\34\1\0\1\35"+
    "\1\0\1\36\1\0\1\37\1\40\1\41\1\42\1\43"+
    "\3\0\1\44\1\0\1\45\1\46\1\47\1\50\1\51"+
    "\1\52\1\0\1\53\1\54\1\55\2\0\1\56\1\0"+
    "\1\57\266\0\2\44\115\0\1\54\u0182\0\1\1\20\0"+
    "\2\1\u0115\0\1\45\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\31\0\1\5"+
    "\40\0\1\5\1\0\1\6\16\0\1\7\124\0\1\10"+
    "\3\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[184];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\60\0\140\0\220\0\300\0\220\0\360\0\220"+
    "\0\u0120\0\u0150\0\u0180\0\u01b0\0\u01e0\0\u0210\0\u0240\0\u0270"+
    "\0\u02a0\0\u02d0\0\u0300\0\220\0\u0330\0\u0360\0\u0390\0\u03c0"+
    "\0\u03f0\0\u0420\0\u0450\0\u0480\0\u04b0\0\u04e0\0\u0510\0\u0540"+
    "\0\u0570\0\u05a0\0\u05d0\0\u0600\0\u0630\0\u0660\0\u0690\0\u06c0"+
    "\0\u06f0\0\u0720\0\u0750\0\u0780\0\u07b0\0\220\0\u07e0\0\u0810"+
    "\0\u0840\0\u0870\0\u08a0\0\u08d0\0\u0900\0\u0930\0\u0960\0\u0990"+
    "\0\u09c0\0\u09f0\0\u0a20\0\u0a50\0\u0a80\0\u0ab0\0\u0ae0\0\u0b10"+
    "\0\u0b40\0\u0b70\0\u0ba0\0\u0bd0\0\u0c00\0\u0c30\0\u0c60\0\u0c90"+
    "\0\u0cc0\0\u0cf0\0\u0d20\0\u0d50\0\u0d80\0\u0db0\0\u0de0\0\u0de0"+
    "\0\220\0\u0e10\0\u0e40\0\u0e70\0\u0ea0\0\u0ed0\0\u0f00\0\u0f30"+
    "\0\u0f60\0\u0f90\0\u0fc0\0\u0ff0\0\u1020\0\u1050\0\u1080\0\220"+
    "\0\u10b0\0\u10e0\0\u1110\0\u1140\0\u1170\0\u11a0\0\u11d0\0\u1200"+
    "\0\u1230\0\u1260\0\u1290\0\u12c0\0\u12f0\0\u1320\0\u1350\0\u1380"+
    "\0\u13b0\0\u13e0\0\u1410\0\u1440\0\u1470\0\u14a0\0\u14d0\0\u1500"+
    "\0\u1530\0\u1560\0\u1590\0\u15c0\0\u15f0\0\u1620\0\u1650\0\u1680"+
    "\0\u16b0\0\u16e0\0\u1710\0\u1740\0\u1770\0\u17a0\0\u17d0\0\u1800"+
    "\0\u1830\0\u1860\0\u1890\0\u18c0\0\u18f0\0\u1920\0\u1950\0\u1980"+
    "\0\u19b0\0\u19e0\0\u1a10\0\u1a40\0\u1a70\0\u1aa0\0\u1ad0\0\u1b00"+
    "\0\u1b30\0\u1b60\0\u1b90\0\u1bc0\0\u1bf0\0\u1c20\0\u1c50\0\u1c80"+
    "\0\u1cb0\0\u1ce0\0\u1d10\0\u1d40\0\u1d70\0\u1da0\0\u1dd0\0\u1e00"+
    "\0\u1e30\0\u1e60\0\u1e90\0\u1ec0\0\u1ef0\0\u1f20\0\u1f50\0\u1f80"+
    "\0\u1fb0\0\u1fe0\0\u2010\0\u2040\0\220\0\u2070\0\u20a0\0\u20d0";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[184];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\34\4\1\5\23\4\34\6\1\7\23\6\34\10\1\11"+
    "\23\10\102\0\1\12\23\0\1\12\17\0\1\13\73\0"+
    "\1\14\23\0\1\14\32\0\1\15\23\0\1\15\34\0"+
    "\1\16\23\0\1\16\32\0\1\17\23\0\1\17\36\0"+
    "\1\20\23\0\1\20\30\0\1\21\23\0\1\21\36\0"+
    "\1\22\23\0\1\22\17\0\1\23\73\0\1\24\23\0"+
    "\1\24\17\0\1\25\61\0\11\26\1\27\10\26\2\0"+
    "\1\26\10\0\1\30\22\0\11\31\1\32\10\31\2\0"+
    "\1\31\10\0\1\33\20\0\1\34\1\0\22\26\2\0"+
    "\1\26\31\0\1\34\1\0\6\26\1\35\13\26\2\0"+
    "\1\26\5\0\1\36\33\0\1\36\23\0\1\36\23\0"+
    "\1\37\1\0\22\31\2\0\1\31\31\0\1\37\1\0"+
    "\6\31\1\40\13\31\2\0\1\31\5\0\1\41\33\0"+
    "\1\41\23\0\1\41\13\0\2\34\2\0\4\34\1\42"+
    "\23\34\2\0\22\34\10\0\1\34\1\0\12\26\1\43"+
    "\7\26\2\0\1\26\11\0\1\44\33\0\1\44\23\0"+
    "\1\44\7\0\2\37\2\0\4\37\1\45\23\37\2\0"+
    "\22\37\10\0\1\37\1\0\12\31\1\46\7\31\2\0"+
    "\1\31\11\0\1\47\33\0\1\47\23\0\1\47\16\0"+
    "\1\50\60\0\1\34\1\0\6\26\1\51\13\26\2\0"+
    "\1\26\5\0\1\52\33\0\1\52\23\0\1\52\22\0"+
    "\1\53\60\0\1\37\1\0\6\31\1\54\13\31\2\0"+
    "\1\31\5\0\1\55\33\0\1\55\23\0\1\55\22\0"+
    "\1\50\25\0\1\56\32\0\1\34\1\0\16\26\1\57"+
    "\3\26\2\0\1\26\15\0\1\60\33\0\1\60\23\0"+
    "\1\60\12\0\1\53\25\0\1\61\32\0\1\37\1\0"+
    "\16\31\1\62\3\31\2\0\1\31\15\0\1\63\33\0"+
    "\1\63\23\0\1\63\13\0\1\34\1\0\17\26\1\64"+
    "\2\26\2\0\1\26\16\0\1\65\33\0\1\65\23\0"+
    "\1\65\2\0\34\66\1\0\23\66\10\0\1\37\1\0"+
    "\17\31\1\67\2\31\2\0\1\31\16\0\1\70\33\0"+
    "\1\70\23\0\1\70\12\0\1\34\1\0\15\26\1\71"+
    "\4\26\2\0\1\26\14\0\1\72\33\0\1\72\23\0"+
    "\1\72\4\0\34\66\1\73\23\66\10\0\1\37\1\0"+
    "\15\31\1\74\4\31\2\0\1\31\14\0\1\75\33\0"+
    "\1\75\23\0\1\75\14\0\1\34\1\0\21\26\1\76"+
    "\2\0\1\26\20\0\1\77\33\0\1\77\23\0\1\77"+
    "\6\0\1\100\61\0\1\37\1\0\21\31\1\101\2\0"+
    "\1\31\20\0\1\102\33\0\1\102\23\0\1\102\10\0"+
    "\1\103\1\0\22\26\2\0\1\26\31\0\1\104\71\0"+
    "\1\105\23\0\1\105\21\0\1\106\1\0\22\31\2\0"+
    "\1\31\31\0\1\106\47\0\2\103\2\0\4\103\1\107"+
    "\23\103\2\0\22\103\2\104\2\0\4\104\1\110\23\104"+
    "\2\0\22\104\21\0\1\111\23\0\1\111\12\0\2\106"+
    "\2\0\4\106\1\112\23\106\2\0\22\106\7\0\1\113"+
    "\57\0\1\114\74\0\1\115\23\0\1\115\16\0\1\116"+
    "\57\0\1\113\25\0\1\117\31\0\1\114\25\0\1\120"+
    "\57\0\1\121\31\0\1\116\25\0\1\122\22\0\34\123"+
    "\1\0\23\123\34\124\1\0\23\124\34\123\1\125\23\123"+
    "\34\124\1\126\23\124\6\0\1\127\57\0\1\130\73\0"+
    "\1\131\23\0\1\131\33\0\1\132\23\0\1\132\32\0"+
    "\1\133\23\0\1\133\33\0\1\134\23\0\1\134\36\0"+
    "\1\135\23\0\1\135\33\0\1\136\23\0\1\136\44\0"+
    "\1\137\57\0\1\140\23\0\2\141\1\0\1\142\5\0"+
    "\1\143\1\0\1\144\17\0\1\145\1\0\1\141\1\143"+
    "\1\0\1\144\17\0\2\141\1\0\1\142\5\0\1\143"+
    "\1\0\1\144\17\0\1\146\1\0\1\141\1\143\1\0"+
    "\1\144\42\0\1\147\23\0\1\147\24\0\1\150\24\0"+
    "\1\150\42\0\1\151\23\0\1\151\30\0\1\152\23\0"+
    "\1\152\33\0\1\153\23\0\1\153\24\0\1\154\24\0"+
    "\1\154\44\0\1\155\23\0\1\155\32\0\1\156\23\0"+
    "\1\156\30\0\1\157\23\0\1\157\33\0\1\160\23\0"+
    "\1\160\42\0\1\161\23\0\1\161\34\0\1\162\23\0"+
    "\1\162\16\0\1\163\24\0\1\163\42\0\1\164\23\0"+
    "\1\164\33\0\1\165\23\0\1\165\35\0\1\166\23\0"+
    "\1\166\36\0\1\167\23\0\1\167\20\0\1\170\24\0"+
    "\1\170\24\0\1\171\57\0\1\172\60\0\1\141\60\0"+
    "\1\173\24\0\1\173\47\0\1\174\23\0\1\174\34\0"+
    "\1\175\23\0\1\175\26\0\1\176\4\0\1\175\16\0"+
    "\1\176\4\0\1\175\34\0\1\177\23\0\1\177\33\0"+
    "\1\200\23\0\1\200\33\0\1\201\23\0\1\201\22\0"+
    "\1\202\23\0\1\202\40\0\1\203\23\0\1\203\33\0"+
    "\1\141\23\0\1\141\34\0\1\204\23\0\1\204\31\0"+
    "\1\205\23\0\1\205\10\0\2\203\1\0\1\206\1\203"+
    "\6\0\1\144\17\0\1\207\1\0\1\203\2\0\1\144"+
    "\50\0\1\210\23\0\1\210\21\0\1\211\23\0\1\211"+
    "\37\0\1\212\23\0\1\212\31\0\1\213\23\0\1\213"+
    "\21\0\1\214\77\0\1\215\23\0\1\215\16\0\1\216"+
    "\24\0\1\216\40\0\1\217\23\0\1\217\12\0\2\214"+
    "\2\0\4\214\1\220\23\214\2\0\22\214\31\0\1\221"+
    "\23\0\1\221\32\0\1\222\23\0\1\222\27\0\1\223"+
    "\23\0\1\223\16\0\1\224\77\0\1\225\23\0\1\225"+
    "\32\0\1\226\23\0\1\226\15\0\1\227\56\0\1\224"+
    "\25\0\1\230\55\0\1\231\23\0\1\231\11\0\1\203"+
    "\76\0\1\232\23\0\1\232\3\0\34\233\1\0\23\233"+
    "\10\0\1\234\100\0\1\235\23\0\1\235\2\0\34\233"+
    "\1\236\23\233\2\234\2\0\4\234\1\237\23\234\2\0"+
    "\22\234\26\0\1\240\23\0\1\240\13\0\1\241\60\0"+
    "\1\242\102\0\1\243\23\0\1\243\23\0\1\244\23\0"+
    "\1\244\20\0\1\242\25\0\1\245\32\0\1\246\70\0"+
    "\1\247\23\0\1\247\12\0\34\250\1\0\23\250\2\246"+
    "\2\0\4\246\1\251\23\246\2\0\22\246\24\0\1\252"+
    "\23\0\1\252\7\0\34\250\1\253\23\250\7\0\1\254"+
    "\105\0\1\141\30\0\1\255\60\0\1\254\25\0\1\256"+
    "\44\0\1\257\23\0\1\257\11\0\34\260\1\0\23\260"+
    "\21\0\1\261\23\0\1\261\12\0\34\260\1\262\23\260"+
    "\24\0\1\263\23\0\1\263\15\0\1\264\106\0\1\265"+
    "\44\0\1\266\23\0\1\266\32\0\1\267\23\0\1\267"+
    "\36\0\1\270\23\0\1\270\44\0\1\203\22\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[8448];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\31\0\1\11\40\0\1\1\1\0\1\11\16\0"+
    "\1\11\124\0\1\11\3\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[184];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S102_JointMinistries() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S102_JointMinistries(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 11: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 12: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 13: break;
          case 6:
            { if( !checkEdge()) {
		
			AnnotationEntity retrievedEntity = retrieveEntity();
			
			offset += yylength();
			position += retrievedEntity.getText().length();
		}
            }
          // fall through
          case 14: break;
          case 7:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		
		if( !annotationEntity.getValue().equals("")) annotationEntity.setValue(annotationEntity.getValue() + ";");
		annotationEntity.setValue(annotationEntity.getValue() + retrievedEntity.getValue());
		
		offset += yylength();
		position += retrievedEntity.getText().length();
            }
          // fall through
          case 15: break;
          case 8:
            { start(new AnnotationEntity(Entity.MINISTRY), ministriesState, false, false);
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S102_JointMinistries [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S102_JointMinistries scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S102_JointMinistries(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
